opscp 3.8 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151
  1. #!/bin/bash
  2. # vim: expandtab:tabstop=4:shiftwidth=4
  3. function usage() {
  4. cat << EOF
  5. Usage: opscp [OPTIONS] local remote
  6. Options:
  7. --version show program's version number and exit
  8. --help show this help message and exit
  9. -l USER, --user=USER username (OPTIONAL)
  10. -p PAR, --par=PAR max number of parallel threads (OPTIONAL)
  11. --outdir=OUTDIR output directory for stdout files (OPTIONAL)
  12. --errdir=ERRDIR output directory for stderr files (OPTIONAL)
  13. -c CLUSTER, --cluster CLUSTER
  14. which cluster to use
  15. -e ENV, --env ENV which environment to use
  16. --v3 When working with v3 environments. v2 by default
  17. -t HOST_TYPE, --host-type HOST_TYPE
  18. which host type to use
  19. --list-host-types list all of the host types
  20. --timeout=TIMEOUT timeout (secs) (0 = no timeout) per host (OPTIONAL)
  21. -O OPTION, --option=OPTION
  22. SSH option (OPTIONAL)
  23. -v, --verbose turn on warning and diagnostic messages (OPTIONAL)
  24. -A, --askpass Ask for a password (OPTIONAL)
  25. -x ARGS, --extra-args=ARGS
  26. Extra command-line arguments, with processing for
  27. spaces, quotes, and backslashes
  28. -X ARG, --extra-arg=ARG
  29. Extra command-line argument
  30. -r, --recursive recusively copy directories (OPTIONAL)
  31. Example: opscp -t ex-srv -e stg -l irb2 foo.txt /home/irb2/foo.txt
  32. EOF
  33. }
  34. if [ $# -eq 0 ] || [ "$1" == "--help" ]
  35. then
  36. usage
  37. exit 1
  38. fi
  39. # See if ohi is installed
  40. if ! which ohi &>/dev/null ; then
  41. echo "ERROR: can't find ohi (OpenShift Host Inventory) on your system, please either install the openshift-ansible-bin package, or add openshift-ansible/bin to your path."
  42. exit 10
  43. fi
  44. PAR=200
  45. USER=root
  46. TIMEOUT=0
  47. ENV=""
  48. HOST_TYPE=""
  49. while [ $# -gt 0 ] ; do
  50. case $1 in
  51. -t|--host-type)
  52. shift # get past the option
  53. HOST_TYPE=$1
  54. shift # get past the value of the option
  55. ;;
  56. -c)
  57. shift # get past the option
  58. CLUSTER=$1
  59. shift # get past the value of the option
  60. ;;
  61. -e)
  62. shift # get past the option
  63. ENV=$1
  64. shift # get past the value of the option
  65. ;;
  66. --v3)
  67. OPENSHIFT_VERSION="--v3 --ip"
  68. shift # get past the value of the option
  69. ;;
  70. --timeout)
  71. shift # get past the option
  72. TIMEOUT=$1
  73. shift # get past the value of the option
  74. ;;
  75. -p|--par)
  76. shift # get past the option
  77. PAR=$1
  78. shift # get past the value of the option
  79. ;;
  80. -l|--user)
  81. shift # get past the option
  82. USER=$1
  83. shift # get past the value of the option
  84. ;;
  85. --list-host-types)
  86. ohi --list-host-types
  87. exit 0
  88. ;;
  89. -h|--hosts|-H|--host|-o)
  90. echo "ERROR: unknown option $1"
  91. exit 20
  92. ;;
  93. *)
  94. args+=("$1")
  95. shift
  96. ;;
  97. esac
  98. done
  99. # Get host list from ohi
  100. CMD=""
  101. if [ -n "$CLUSTER" ] ; then
  102. CMD="$CMD -c $CLUSTER"
  103. fi
  104. if [ -n "$ENV" ] ; then
  105. CMD="$CMD -e $ENV"
  106. fi
  107. if [ -n "$HOST_TYPE" ] ; then
  108. CMD="$CMD -t $HOST_TYPE"
  109. fi
  110. if [ -n "$OPENSHIFT_VERSION" ] ; then
  111. CMD="$CMD $OPENSHIFT_VERSION"
  112. fi
  113. if [ -n "$CMD" ] ; then
  114. HOSTS="$(ohi $CMD 2>/dev/null)"
  115. OHI_ECODE=$?
  116. fi
  117. if [ $OHI_ECODE -ne 0 ] ; then
  118. echo
  119. echo "ERROR: ohi failed with exit code $OHI_ECODE"
  120. echo
  121. echo "This is usually caused by a bad value passed for host-type or environment."
  122. echo
  123. exit 25
  124. fi
  125. exec pscp.pssh -t $TIMEOUT -p $PAR -l $USER -h <(echo "$HOSTS") "${args[@]}"